technique T0
{
    pass P0
    {
		SpecularEnable = true;

        AddressU[0]		= Wrap;
		AddressV[0]		= Wrap;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		MipFilter[0]	= Point;

        AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		MipFilter[1]	= Linear;

        VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            stream 1;
            short v1[2];	// Texture coord1
            stream 2;
            D3DCOLOR v2;	// Normal
            stream 3;
            D3DCOLOR v3;	// Basis, S
            D3DCOLOR v4;	// Basis, T
            stream 4;
            D3DCOLOR v6;	// Influences indices
            stream 5;
            float v7[4];	// Influences weights
            stream 6;
            D3DCOLOR v5;	// Colors
            stream 7;
            float  v8[3];	// Delta 0
            float  v9[3];	// Delta 1
            float v10[3];	// Delta 2
            float v11[3];	// Delta 3
            float v12[3];	// Delta 4
            float v13[3];	// Delta 5
            float v14[3];	// Delta 6
            float v15[3];	// Delta 7
        }
		asm
		{
			vs.1.1

			mul		r0, v6, c91.y

			mov		r9, v0
			mad		r9.xyz,  v8, c63.x, r9					// Perform blend
			mad		r9.xyz,  v9, c63.y, r9					// Perform blend
			mad		r9.xyz, v10, c63.z, r9					// Perform blend
			mad		r9.xyz, v11, c63.w, r9					// Perform blend
			mad		r9.xyz, v12, c80.x, r9					// Perform blend
			mad		r9.xyz, v13, c80.y, r9					// Perform blend
			mad		r9.xyz, v14, c80.z, r9					// Perform blend
			mad		r9.xyz, v15, c80.w, r9					// Perform blend

			// First Influence on position
			mov		a0.x, r0.x
			m4x3	r1, r9, c[a0.x]
			mul		r2.xyz, r1.xyz, v7.x			// Weighted sum of positions

			// First Influence on basis
			//
			// r3 will hold the decompressed S (v3)
			// r4 will hold the decompressed T (v4)
			// r5 will hold the decompressed SxT (v2)
			//
			// r6 will hold the weighted sum of S
			// r7 will hold the weighted sum of T
			// r8 will hold the weighted sum of SxT

			mad		r3, v3, c91.z, -v3.w			// EXPECTING 1.0 to be in v3.w
			m3x3	r1, r3, c[a0.x]					// Deform S
			mul		r6.xyz, r1.xyz, v7.x			// Weighted sum of basis

			mad		r4, v4, c91.z, -v4.w			// EXPECTING 1.0 to be in v4.w
			m3x3	r1, r4, c[a0.x]					// Deform T
			mul		r7.xyz, r1.xyz, v7.x			// Weighted sum of basis

			mad		r5, v2, c91.z, -v2.w			// EXPECTING 1.0 to be in v2.w
			m3x3	r1, r5, c[a0.x]					// Deform SxT (normal)
			mul		r8.xyz, r1.xyz, v7.x			// Weighted sum of basis


			// Second Influence on position
			mov		a0.x, r0.y
			m4x3	r1, r9, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.y, r2.xyz

			// Second Influence on basis
			m3x3	r1, r3, c[a0.x]					// Deform S
			mad		r6.xyz, r1.xyz, v7.y, r6.xyz	// Weighted sum of basis

			m3x3	r1, r4, c[a0.x]					// Deform T
			mad		r7.xyz, r1.xyz, v7.y, r7.xyz	// Weighted sum of basis

			m3x3	r1, r5, c[a0.x]					// Deform SxT (normal)
			mad		r8.xyz, r1.xyz, v7.y, r8.xyz	// Weighted sum of basis


			// Third Influence on position
			mov		a0.x, r0.z
			m4x3	r1, r9, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.z, r2.xyz

			// Third influence on basis
			m3x3	r1, r3, c[a0.x]					// Deform S
			mad		r6.xyz, r1.xyz, v7.z, r6.xyz	// Weighted sum of basis

			m3x3	r1, r4, c[a0.x]					// Deform T
			mad		r7.xyz, r1.xyz, v7.z, r7.xyz	// Weighted sum of basis

			m3x3	r1, r5, c[a0.x]					// Deform SxT (normal)
			mad		r8.xyz, r1.xyz, v7.z, r8.xyz	// Weighted sum of basis


			// Fourth Influence on position
			mov		a0.x, r0.w
			m4x3	r1, r9, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.w, r2.xyz
			sge		r2.w, r0, r0


			// Fourth Influence on basis
			m3x3	r1, r3, c[a0.x]					// Deform S
			mad		r6.xyz, r1.xyz, v7.w, r6.xyz	// Weighted sum of basis

			m3x3	r1, r4, c[a0.x]					// Deform T
			mad		r7.xyz, r1.xyz, v7.w, r7.xyz	// Weighted sum of basis

			m3x3	r1, r5, c[a0.x]					// Deform SxT (normal)
			mad		r8.xyz, r1.xyz, v7.w, r8.xyz	// Weighted sum of basis

			// Perform blend
			mad		r3, r9, -c91.w, r9
			mad		r3, r2, c91.w, r3

			// Apply view+projection to result
			m4x4	r1, r3, c92
			mov		oPos, r1
			mov		oFog.x, r1.w					// Handle fog


			// Move the uvs through... (they are scaled up, so we have to bring 'em down)
			mul		oT0.xyz, v1, c87
			mul		oT1.xyz, v1, c87
		};

        PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1

			mov r0.rgb, v0				// RGB gets black
			+ mul r0.a, t1.a, c1.a		// Alpha gets texture * diffuse
        };
    }
}
