technique T0
{
    pass P0
    {
		SpecularEnable = true;

		// Set shadow buffer args
        AddressU[0]		= Wrap;
		AddressV[0]		= Wrap;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		MipFilter[0]	= Point;

        AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		MipFilter[1]	= Linear;

        AddressU[2]		= Clamp;
		AddressV[2]		= Clamp;
		MinFilter[2]	= Linear;
		MagFilter[2]	= Linear;
		MipFilter[2]	= Point;

        AddressU[3]		= Clamp;
		AddressV[3]		= Clamp;
		MinFilter[3]	= Linear;
		MagFilter[3]	= Linear;
		MipFilter[3]	= Point;

        VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            stream 1;
            short v1[2];	// Texture coord1
            stream 2;
            D3DCOLOR v2;	// Normal
            stream 3;
            D3DCOLOR v3;	// Basis, S
            D3DCOLOR v4;	// Basis, T
            stream 4;
            D3DCOLOR v6;	// Influences indices
            stream 5;
            float v7[4];	// Influences weights
            stream 6;
            D3DCOLOR v5;	// Colors
            stream 7;
            float  v8[3];	// Delta 0
            float  v9[3];	// Delta 1
            float v10[3];	// Delta 2
            float v11[3];	// Delta 3
            float v12[3];	// Delta 4
            float v13[3];	// Delta 5
            float v14[3];	// Delta 6
            float v15[3];	// Delta 7
        }
		asm
		{
			vs.1.1

			mul		r0, v6, c91.y

			mov		r9, v0
			mad		r9.xyz,  v8, c63.x, r9					// Perform blend
			mad		r9.xyz,  v9, c63.y, r9					// Perform blend
			mad		r9.xyz, v10, c63.z, r9					// Perform blend
			mad		r9.xyz, v11, c63.w, r9					// Perform blend
			mad		r9.xyz, v12, c80.x, r9					// Perform blend
			mad		r9.xyz, v13, c80.y, r9					// Perform blend
			mad		r9.xyz, v14, c80.z, r9					// Perform blend
			mad		r9.xyz, v15, c80.w, r9					// Perform blend

			// First Influence on position
			mov		a0.x, r0.x
			m4x3	r1, r9, c[a0.x]
			mul		r2.xyz, r1.xyz, v7.x			// Weighted sum of positions

			// First Influence on basis
			//
			// r3 will hold the decompressed S (v3)
			// r4 will hold the decompressed T (v4)
			// r5 will hold the decompressed SxT (v2)
			//
			// r6 will hold the weighted sum of S
			// r7 will hold the weighted sum of T
			// r8 will hold the weighted sum of SxT

			mad		r3, v3, c91.z, -v3.w			// EXPECTING 1.0 to be in v3.w
			m3x3	r1, r3, c[a0.x]					// Deform S
			mul		r6.xyz, r1.xyz, v7.x			// Weighted sum of basis

			mad		r4, v4, c91.z, -v4.w			// EXPECTING 1.0 to be in v4.w
			m3x3	r1, r4, c[a0.x]					// Deform T
			mul		r7.xyz, r1.xyz, v7.x			// Weighted sum of basis

			mad		r5, v2, c91.z, -v2.w			// EXPECTING 1.0 to be in v2.w
			m3x3	r1, r5, c[a0.x]					// Deform SxT (normal)
			mul		r8.xyz, r1.xyz, v7.x			// Weighted sum of basis


			// Second Influence on position
			mov		a0.x, r0.y
			m4x3	r1, r9, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.y, r2.xyz

			// Second Influence on basis
			m3x3	r1, r3, c[a0.x]					// Deform S
			mad		r6.xyz, r1.xyz, v7.y, r6.xyz	// Weighted sum of basis

			m3x3	r1, r4, c[a0.x]					// Deform T
			mad		r7.xyz, r1.xyz, v7.y, r7.xyz	// Weighted sum of basis

			m3x3	r1, r5, c[a0.x]					// Deform SxT (normal)
			mad		r8.xyz, r1.xyz, v7.y, r8.xyz	// Weighted sum of basis


			// Third Influence on position
			mov		a0.x, r0.z
			m4x3	r1, r9, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.z, r2.xyz

			// Third influence on basis
			m3x3	r1, r3, c[a0.x]					// Deform S
			mad		r6.xyz, r1.xyz, v7.z, r6.xyz	// Weighted sum of basis

			m3x3	r1, r4, c[a0.x]					// Deform T
			mad		r7.xyz, r1.xyz, v7.z, r7.xyz	// Weighted sum of basis

			m3x3	r1, r5, c[a0.x]					// Deform SxT (normal)
			mad		r8.xyz, r1.xyz, v7.z, r8.xyz	// Weighted sum of basis


			// Fourth Influence on position
			mov		a0.x, r0.w
			m4x3	r1, r9, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.w, r2.xyz
			sge		r2.w, r0, r0


			// Fourth Influence on basis
			m3x3	r1, r3, c[a0.x]					// Deform S
			mad		r6.xyz, r1.xyz, v7.w, r6.xyz	// Weighted sum of basis

			m3x3	r1, r4, c[a0.x]					// Deform T
			mad		r7.xyz, r1.xyz, v7.w, r7.xyz	// Weighted sum of basis

			m3x3	r1, r5, c[a0.x]					// Deform SxT (normal)
			mad		r8.xyz, r1.xyz, v7.w, r8.xyz	// Weighted sum of basis

			// Perform blend
			mad		r3, r9, -c91.w, r9
			mad		r3, r2, c91.w, r3

			// Apply view+projection to result
			m4x4	r1, r3, c92
			mov		oPos, r1
			mov		oFog.x, r1.w					// Handle fog

			// Transform light0 direction vector into tangent space
			dp3		r5.x,	r6,			-c88					// xform light into tangent space
			dp3		r5.y,	r7,			-c88
			dp3		r5.z,	r8,			-c88

			dp3		r5.w,	r5,			r5						// Normalize
			rsq		r5.w,	r5.w
			mul		r5,		r5,			r5.w

			mad		oD0.xyz,	r5,		c86.y,		c86.y		// Transform from -1..1 to 0..1, half == 0.5f
			mov		oD0.w,		v5.y							// Use the green component of the color


			// transform vertex position to world space
			//  to calculate V, vector to viewer in world
			//  space.

			// Half angle vector is  (L+V)/||L+V||  or Normalize( L+V )
			//  ||a|| is magnitude of a
			//  L = vec to light from vertex point
			//  V = vec to viewer from vertex point
			// vertex position - eye position
			// eye position - vertex position
			add		r5,  c90.xyz, -r3.xyz

			// Normalize eye vec
			dp3		r5.w, r5, r5
			rsq		r5.w, r5.w
			mul		r5, r5, r5.w

			// Add them to average & create half angle vector
			add		r4,  -c88, r5

			//  Normalize it
			dp3		r4.w, r4, r4
			rsq		r4.w, r4.w
			mul		r4,   r4, r4.w

			/////////////////////////////////////////////////
			// Transform half angle vector to local space and
			//  output to specular register for specular calc

			dp3		r6.x, r4, r6
			dp3		r6.y, r4, r7
			dp3		r6.z, r4, r8
			mad		oD1.xyz,	r6,		c86.y,		c86.y		// Transform from -1..1 to 0..1, half == 0.5f


			// Move the uvs through... (they are scaled up, so we have to bring 'em down)
			mul		oT0.xyz, v1, c87
			mul		oT1.xyz, v1, c87

			// Compute uvs for shadow buffers
			m4x4	r1, r3, c72
			max		oT2, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)

			// Compute uvs for shadow buffers
			m4x4	r1, r3, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)			
		};

        PixelShader = 
        asm
        {
            xps.1.1

			// c0 = ambient color
			// c1 = diffuse color
			// c2 = specular color
			// c3 = backlight color

			tex t0													// Normal map
			tex t1													// Detail texture map
			tex t2													// Shadow map
			tex t3													// Shadow map

			xmma discard.rgb, discard.rgb, t3.rgb, 1-t3, c3.a, t3, 1-zero	// Modulate the self-shadow
			+ mul t2.a, t2.b, v0.a									// Mul in the ambient occlusion term

			xdd r0.rgb, r1.rgb, t0_bx2, v0_bx2, t0_bx2, v1_bx2		// r0.rgb = diffuse intensity (t0_bx2 dot v0_bx2)
			+ mul t2.a, t2.a, t3.b									// r1.rgb = specular intensity (t0_bx2 dot v1_bx2)
																	// t2.a = shadow intensity (t2.a = t2.b * t3.b)


			xmma t0.rgb, r1.rgb, discard.rgb, r0_sat, t2.a, r0, -c3	// t0.rgb = shadowed diffuse intensity (r0_sat * t2.a)
			+ mul r1.a, r1_sat.b, r1_sat.b							// r1.rgb = backlight
																	// r1.a = specular intensity ^ 2

			mul_d2 r0.rgb, r0_sat, c0								// r0.rgb = partial ambient
			+ mul r1.a, r1.a, r1.a									// r1.a = specular intensity ^ 4

			mad r1.rgb, r0, 1-t2.a, r1_sat							// r1.rgb = partial ambient * (1 - shadow) + backlighting
			+ mul r1.a, r1.a, r1.a									// r1.a = specular intensity ^ 8

			mad r0.rgb, t0, c1, c0									// r0.rgb = final diffuse
			+ mul r1.a, r1.a, t0.a									// r1.a = specular intensity * specular map

			add r0.rgb, r0, r1										// r0.rgb = final diffuse + final backlighting
			+ mul t1.a, t1.a, c1.a

			xmma t2.rgb, r0.rgb, discard.rgb, t2.a, c2, r0, t1		// t2.rgb = specular color * shadow

			xfc fog.a, r0, fog, prod, r1.a, t2, t1.a				// final color
			//xfc r0, t1, zero, prod, r1.a, t2, t1.a					// final color
//xfc t3, 1-zero, zero, zero, zero, zero, t1.a					// final color
        };
    }
}
