technique T0
{
    pass P0
    {
        AddressU[0]		= Wrap;
		AddressV[0]		= Wrap;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		MipFilter[0]	= Linear;
		
        AddressU[1]		= Clamp;
		AddressV[1]		= Clamp;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		MipFilter[1]	= Point;

        VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            stream 1;
            short v1[2];	// Texture coord1
            stream 2;
            D3DCOLOR v2;	// Normal
            stream 4;
            D3DCOLOR v6;	// Influences indices
            stream 5;
            float v7[4];	// Influences weights
        }
		asm
		{
			vs.1.1

			mul		r0, v6, c91.y

			// First Influence on position
			mov		a0.x, r0.x
			m4x3	r1, v0, c[a0.x]
			mul		r2.xyz, r1.xyz, v7.x			// Weighted sum of positions

			// Second Influence on position
			mov		a0.x, r0.y
			m4x3	r1, v0, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.y, r2.xyz

			// Third Influence on position
			mov		a0.x, r0.z
			m4x3	r1, v0, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.z, r2.xyz

			// Fourth Influence on position
			mov		a0.x, r0.w
			m4x3	r1, v0, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.w, r2.xyz
			sge		r2.w, v0, v0

			// Perform blend
			mad		r3, v0, -c91.w, v0
			mad		r2, r2, c91.w, r3
			
			// Apply view+proj
			m4x4	r0, r2, c92
			mov		oPos, r0
			mov		oFog.x, r0.w		// Handle fog

			// Lighting (diffuse + ambient + emissive)
			mad		r4, v2, c91.z, -v2.w	// EXPECTING 1.0 to be in v2.w
			dp3		r4, r4, -c81			// Dot for diffuse
			lit		r4, r4
			mul		oD0, r4.yyyw, c83

			// Move the uvs through... (they are scaled up, so we have to bring 'em down)
			mul		oT0.xyz, v1, c87
			
			// Compute uvs for shadow buffers
			m4x4	r0, r2, c68
			max		oT1, r0, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};

		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1

			mad r0, v0, t1, c0
			mul r0.rgb, r0, t0
			+mul r0.a, t0.a, c1.a
		};
    }
}
