technique T0
{
    pass P0
    {
        AddressU[0]		= Clamp;
		AddressV[0]		= Clamp;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		MipFilter[0]	= Linear;

        AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		MipFilter[1]	= Linear;

        VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            stream 1;
            short v1[2];	// Texture coord1
            stream 4;
            D3DCOLOR v6;	// Influences indices
            stream 5;
            float v7[4];	// Influences weights
        }
		asm
		{
			vs.1.1

			mul		r0, v6, c91.y

			// First Influence on position
			mov		a0.x, r0.x
			m4x3	r1, v0, c[a0.x]
			mul		r2.xyz, r1.xyz, v7.x			// Weighted sum of positions

			// Second Influence on position
			mov		a0.x, r0.y
			m4x3	r1, v0, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.y, r2.xyz

			// Third Influence on position
			mov		a0.x, r0.z
			m4x3	r1, v0, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.z, r2.xyz

			// Fourth Influence on position
			mov		a0.x, r0.w
			m4x3	r1, v0, c[a0.x]
			mad		r2.xyz, r1.xyz, v7.w, r2.xyz
			sge		r2.w, v0, v0

			// Perform blend
			mad		r3, v0, -c91.w, v0
			mad		r2, r2, c91.w, r3

			// Apply view+proj
			m4x4	oPos, r2, c92

			// Move the uvs through... (they are scaled up, so we have to bring 'em down)
			mul		oT0.xyz, v1, c87
			mul		oT1.xyz, v1, c87
		};

		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1

			mov r0.rgb, v0				// RGB gets black
			+ mul r0.a, t1.a, c1.a		// Alpha gets texture * diffuse
        };		
    }
}
