technique T0
{
    pass P0
    {
		// Disable specular
		SpecularEnable = False;
		
		// Set texture address mode and min mag filters
		AddressU[0]		= Wrap;
		AddressV[0]		= Wrap;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		MipFilter[0]	= Linear;
		
		// Set volume args       
        AddressU[1]		= Clamp;
		AddressV[1]		= Clamp;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		MipFilter[1]	= Point;

		// Set shadow buffer args       
        AddressU[2]		= Clamp;
		AddressV[2]		= Clamp;
		MinFilter[2]	= Linear;
		MagFilter[2]	= Linear;
		MipFilter[2]	= Point;

        VertexShader =
        decl
        {
            stream 0;
            float v0[3]; // Position
            stream 1;
            short v1[2]; // Texture coord1
        }
		asm
		{
			vs.1.1

			m4x3	r1, v0, c0
			sge		r1.w, v0, v0
			
			// Apply view+proj
			m4x4	r0, r1, c92
			mov		oPos, r0
			mov		oFog.x, r0.w		// Handle fog

			// Move the uvs through... (they are scaled up, so we have to bring 'em down)
			mul		oT0.xyz, v1, c87

			// Compute uvs for shadow buffers
			m4x4	r2, r1, c72
			max		oT2, r2, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)

			// Compute the volume uvw from the model-space position (pos) and the bounding box information
			m4x4 oT1, v0, c68
		};

		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0							// Detail texture
			tex t1							// Volume texture
			tex t2							// Shadow texture

			mov r1.a, t1.b					// Get volume intensity
			lrp t1, r1.a, c1, c2			// Perform linear interpolation between primary and secondary colors
			mad r0.rgb, t1, t2, c0			// Mul shadow by diffuse (interpolation from previous step) and add ambient to shadow
			mul r0.rgb, r0, t0				// Now modulate the detail texture
			+ mul r0.a, t0.a, c1.a			// Modulate the texture alpha with the diffuse alpha
        };
    }
}
