technique T0
{
    pass P0
    {
		// Constants Expected:
		// c92-c95: CV_VIEWPROJ
		// c1: minimum alpha
		// c2: maximum alpha
		// c3: slope of the equation
		// c4: diffuse color
    
		// Disable specular
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= True;
		
		// First stage
		ColorOp[0]   = Disable;
        AlphaOp[0]   = Disable;
        
        // Second stage
        // Only one color being used
        ColorOp[1]   = Disable;
        AlphaOp[1]   = Disable;
	
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
        }
		asm
		{
			vs.1.1						// Vertex shader version 1.1
			m4x4 r0, v0, c92		// Transform position, Apply view+proj
			
			mov r6.xyz, c4.xyz		// copy the constant diffuse color, except alpha	
			mov r2.w, c2.w			// copy the max alpha
			
			mad r3.w, r0.w, c3.w, r2.w	// calculate the alpha fog using slope-intercept line equation
			max r4.w, r3.w, c1.w	// ensure it doesn't fall below a min alpha
			min r5.w, r4.w, r2.w		// ensure it doesn't fall below a max alpha

			mov r6.w, r5.w			// override the diffuse color's alpha with the alpha fog
			mov oD0, r6				// move the new fogged color into Diffuse Color output
			mov oPos, r0				// move vertex to the output vertex register
		};		
		
   }
    
}

