technique T0
{
    pass P0
    {
		// Disable specular
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= True;
		
		// Set alpha blending mode
		AlphaBlendEnable = True;
		SrcBlend		= SrcAlpha;
		DestBlend		= InvSrcAlpha;
		
 		AddressU[0]		= Clamp;
		AddressV[0]		= Wrap;
		MipFilter[0]	= None;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		
		AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MipFilter[1]	= Linear;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		
		AddressU[2]		= Wrap;
		AddressV[2]		= Wrap;
		MipFilter[2]	= Linear;
		MinFilter[2]	= Linear;
		MagFilter[2]	= Linear;
		
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			m4x4	oPos, v0, c92
			
			// No Lighting

			// Move the uvs through...
			mul		r0, v7, c91.x
			add		oT0.xyz, r0, c60
			mul		r0, v8, c91.x
			add		oT1.xyz, r0, c61
			mul		r0, v9, c91.x
			add		oT2.xyz, r0, c62
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2

			lrp r0, t2.a, t2, t1

			mul r0.a, r0.a, t0.a
        };    
    }
    
    pass P1
    {
		// Disable specular
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= True;
		
		// Set alpha blending mode
//		AlphaBlendEnable = True;
//		SrcBlend		= Zero;
//		DestBlend		= SrcColor;
		
		// Set shadow map args
 		AddressU[0]		= Clamp;
		AddressV[0]		= Clamp;
		MipFilter[0]	= Linear;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
	
		// Set shadow buffer args
 		AddressU[1]		= Clamp;
		AddressV[1]		= Clamp;
		MipFilter[1]	= Linear;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		 
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
        }
		asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			m4x4	r0, v0, c92
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			mad		r0, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			dp3		r1, r0, -c81			// Dot for diffuse
			lit		r1, r1
			mul		oD0, r1.yyyw, c83
			
			// Compute uvs for shadow buffers
			m4x4	r2, v0, c76
			max		oT0, r2, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
			
			// Compute uvs for shadow buffers
			m4x4	r3, v0, c72
			max		oT1, r3, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1

			mul r0.rgb, v0, t0
			+add t1.a, t1.b, c0.a
			mad r0.rgb, r0, t1.a, c0
			+mov r0.a, v0.a
        };    
    }
}

technique T1
{
    pass P0
    {
		// Disable specular
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= True;
		
		// Set alpha blending mode
		AlphaBlendEnable = True;
		SrcBlend		= SrcAlpha;
		DestBlend		= InvSrcAlpha;
		
 		AddressU[0]		= Clamp;
		AddressV[0]		= Wrap;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		
		AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		
		AddressU[2]		= Wrap;
		AddressV[2]		= Wrap;
		MinFilter[2]	= Linear;
		MagFilter[2]	= Linear;
		
        // First stage
        ColorOp[0]   = SelectArg1;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Texture;
        AlphaOp[0]   = SelectArg1;
        AlphaArg1[0] = Texture;
        AlphaArg2[0] = Texture;
        
        // Second stage
        ColorOp[1]   = SelectArg1;
        ColorArg1[1] = Texture;
        ColorArg2[1] = Current;
        AlphaOp[1]   = SelectArg1;
        AlphaArg1[1] = Texture;
        AlphaArg2[1] = Current;
        
        // Third stage
        ColorOp[2]   = BlendTextureAlpha;
        ColorArg1[2] = Texture;
        ColorArg2[2] = Current;
        AlphaOp[2]   = SelectArg1;
        AlphaArg1[2] = Texture;
        AlphaArg2[2] = Current;
        
        // Fourth stage
        ColorOp[3]   = Modulate;
        ColorArg1[3] = Diffuse;
        ColorArg2[3] = Texture;
        AlphaOp[3]   = Disable;
         
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            float v3[3];	// Normal
            stream 1;
            float v7[2];	// UV
            stream 2;
            float v8[2];	// UV
            stream 3;
            float v9[2];	// UV
        };     
    }
}

technique T2
{
    pass P0
    {
		// Disable specular
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= True;
		
		// Set alpha blending mode
		AlphaBlendEnable = True;
		SrcBlend		= SrcAlpha;
		DestBlend		= InvSrcAlpha;
		
		AddressU[0]		= Clamp;
		AddressV[0]		= Wrap;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		
		AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		
//		AddressU[2]		= Wrap;
//		AddressV[2]		= Wrap;
//		MinFilter[2]	= Linear;
//		MagFilter[2]	= Linear;
		
        // First stage
        ColorOp[0]   = SelectArg1;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Texture;
        AlphaOp[0]   = SelectArg1;
        AlphaArg1[0] = Texture;
        AlphaArg2[0] = Texture;
        
        // Second stage
        ColorOp[1]   = SelectArg1;
        ColorArg1[1] = Texture;
        ColorArg2[1] = Current;
        AlphaOp[1]   = SelectArg1;
        AlphaArg1[1] = Texture;
        AlphaArg2[1] = Current;
        
        // Third stage
//        ColorOp[2]   = BlendTextureAlpha;
//        ColorArg1[2] = Texture;
//        ColorArg2[2] = Current;
//        AlphaOp[2]   = SelectArg1;
        AlphaArg1[2] = Texture;
        AlphaArg2[2] = Current;
        
        // Fourth stage
        ColorOp[2]   = Modulate;
        ColorArg1[2] = Diffuse;
        ColorArg2[2] = Texture;
        AlphaOp[2]   = Disable;
         
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            float v3[3];	// Normal
            stream 1;
            float v7[2];	// UV
            stream 2;
            float v8[2];	// UV
//            stream 3;
//            float v9[2];	// UV
        };     
    }
}