technique T0
{
    pass P0
    {
        // Z-buffering to be used
        ZEnable	     = true;
        ZWriteEnable = true;

		// Texture render state

		AddressU[0] = Clamp;
		AddressV[0] = Clamp;
		MagFilter[0] = Linear;
		MinFilter[0] = Linear;
		MipFilter[0] = Linear;

		AddressU[1] = Clamp;
		AddressV[1] = Clamp;
		MagFilter[1] = Linear;
		MinFilter[1] = Linear;
		MipFilter[1] = Linear;

        VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            stream 1;
            float v1[2];	// Offset (radius, height)
            stream 2;
            short v2[2];	// UVs
        }
		asm
		{
			vs.1.1

			// Apply the world transform
			mov		r1, v0
         
			// Apply the offsets
			mad		r2.xyz, c88, v1.xxy, r1      // p0 = (p1 * p2) + p3
			sge		r2.w, v0, v0				// set w to 1
			
			// Apply view+proj
			m4x4	r0, r2, c92
			mov		oPos, r0
			mov		oFog.x, r0.w		// Handle fog
			
			// Convert from fixed-point to floating point uvs
			mul		oT0.xyz, v2, c91.x
			
			// Compute uvs for shadow buffers
			m4x4	r1, r2, c68
			max		oT1, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
        PixelShader =
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0					// Detail texture
			tex t1					// Shadow texture

			add t1, t1, c0
			mul r0.rgb, t1_sat, t0
			+ mov r0.a, t0.a
        };
    }
}
