technique T0
{
    pass P0
    {
		// Disable specular
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= True;
		
		// Set alpha blending mode
		AlphaBlendEnable = True;
		SrcBlend		= SrcAlpha;
		DestBlend		= InvSrcAlpha;
		
		// Set texture address mode and min mag filters
		AddressU[0]		= Clamp;
		AddressV[0]		= Wrap;
		MipFilter[0]	= None;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		
		AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MipFilter[1]	= Linear;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		
		AddressU[2]		= Wrap;
		AddressV[2]		= Wrap;
		MipFilter[2]	= Linear;
		MinFilter[2]	= Linear;
		MagFilter[2]	= Linear;
				
		// Set shadow buffer args
        AddressU[3]		= Clamp;
		AddressV[3]		= Clamp;
		MipFilter[3]	= Linear;
		MinFilter[3]	= Linear;
		MagFilter[3]	= Linear;
		
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			mad		r3, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			mad		r1, r3, c50.xxxw, v0	// multiply normal by constant
			m4x4	r0, r1, c92				// Apply view+proj
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			dp3		r2, r3, -c81			// Dot for diffuse
			lit		r2, r2
			mul		oD0, r2.yyyw, c83

			// Move the uvs through...
			mul		r0, v7, c91.x			// scale UVs
			add		oT0.xyz, r0, c60		// mov UVs for alpha texture
			
			mul		oT1.xyz, v0, c58		// generate uv's for grass texture
			
			mul		r0, v9, c91.x			// scale UVs
			add		oT2.xyz, r0, c62		// mov UVs for alpha texture

			// Compute uvs for shadow buffers
			m4x4	r1, v0, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2
			tex t3

			mad r0.rgb, v0, t3, c0
			+mov r0.a, v0.a
			mul_x2 r1.rgb, t1, t2
			mul r0.rgb, r0, r1
			+mul r0.a, 1-t0.a, t1.a
        };   
    }
    
    pass P1
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			mad		r3, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			mad		r1, r3, c50.yyyw, v0	// multiply normal by constant
			m4x4	r0, r1, c92				// Apply view+proj
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			dp3		r2, r3, -c81			// Dot for diffuse
			lit		r2, r2
			mul		oD0, r2.yyyw, c83

			// Move the uvs through...
			mul		r0, v7, c91.x			// scale UVs
			add		oT0.xyz, r0, c60		// mov UVs for alpha texture
			
			mul		oT1.xyz, v0, c58		// generate uv's for grass texture
			
			mul		r0, v9, c91.x			// scale UVs
			add		oT2.xyz, r0, c62		// mov UVs for alpha texture

			// Compute uvs for shadow buffers
			m4x4	r1, v0, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2
			tex t3

			mad r0.rgb, v0, t3, c0
			+mov r0.a, v0.a
			mul_x2 r1.rgb, t1, t2
			mul r0.rgb, r0, r1
			+mul r0.a, 1-t0.a, t1.a
        };   
    }
    
    pass P2
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			mad		r3, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			mad		r1, r3, c50.zzzw, v0	// multiply normal by constant
			m4x4	r0, r1, c92				// Apply view+proj
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			dp3		r2, r3, -c81			// Dot for diffuse
			lit		r2, r2
			mul		oD0, r2.yyyw, c83

			// Move the uvs through...
			mul		r0, v7, c91.x			// scale UVs
			add		oT0.xyz, r0, c60		// mov UVs for alpha texture
			
			mul		oT1.xyz, v0, c58		// generate uv's for grass texture
			
			mul		r0, v9, c91.x			// scale UVs
			add		oT2.xyz, r0, c62		// mov UVs for alpha texture

			// Compute uvs for shadow buffers
			m4x4	r1, v0, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2
			tex t3

			mad r0.rgb, v0, t3, c0
			+mov r0.a, v0.a
			mul_x2 r1.rgb, t1, t2
			mul r0.rgb, r0, r1
			+mul r0.a, 1-t0.a, t1.a
        };   
    }
    
    pass P3
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			mad		r3, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			mad		r1, r3, c51.xxxw, v0	// multiply normal by constant
			m4x4	r0, r1, c92				// Apply view+proj
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			dp3		r2, r3, -c81			// Dot for diffuse
			lit		r2, r2
			mul		oD0, r2.yyyw, c83

			// Move the uvs through...
			mul		r0, v7, c91.x			// scale UVs
			add		oT0.xyz, r0, c60		// mov UVs for alpha texture
			
			mul		oT1.xyz, v0, c58		// generate uv's for grass texture
			
			mul		r0, v9, c91.x			// scale UVs
			add		oT2.xyz, r0, c62		// mov UVs for alpha texture

			// Compute uvs for shadow buffers
			m4x4	r1, v0, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2
			tex t3

			mad r0.rgb, v0, t3, c0
			+mov r0.a, v0.a
			mul_x2 r1.rgb, t1, t2
			mul r0.rgb, r0, r1
			+mul r0.a, 1-t0.a, t1.a
        };   
    }
    
    pass P4
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			mad		r3, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			mad		r1, r3, c51.yyyw, v0	// multiply normal by constant
			m4x4	r0, r1, c92				// Apply view+proj
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			dp3		r2, r3, -c81			// Dot for diffuse
			lit		r2, r2
			mul		oD0, r2.yyyw, c83

			// Move the uvs through...
			mul		r0, v7, c91.x			// scale UVs
			add		oT0.xyz, r0, c60		// mov UVs for alpha texture
			
			mul		oT1.xyz, v0, c58		// generate uv's for grass texture
			
			mul		r0, v9, c91.x			// scale UVs
			add		oT2.xyz, r0, c62		// mov UVs for alpha texture

			// Compute uvs for shadow buffers
			m4x4	r1, v0, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2
			tex t3

			mad r0.rgb, v0, t3, c0
			+mov r0.a, v0.a
			mul_x2 r1.rgb, t1, t2
			mul r0.rgb, r0, r1
			+mul r0.a, 1-t0.a, t1.a
        };   
    }
    
    pass P5
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			mad		r3, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			mad		r1, r3, c51.zzzw, v0	// multiply normal by constant
			m4x4	r0, r1, c92				// Apply view+proj
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			dp3		r2, r3, -c81			// Dot for diffuse
			lit		r2, r2
			mul		oD0, r2.yyyw, c83

			// Move the uvs through...
			mul		r0, v7, c91.x			// scale UVs
			add		oT0.xyz, r0, c60		// mov UVs for alpha texture
			
			mul		oT1.xyz, v0, c58		// generate uv's for grass texture
			
			mul		r0, v9, c91.x			// scale UVs
			add		oT2.xyz, r0, c62		// mov UVs for alpha texture

			// Compute uvs for shadow buffers
			m4x4	r1, v0, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2
			tex t3

			mad r0.rgb, v0, t3, c0
			+mov r0.a, v0.a
			mul_x2 r1.rgb, t1, t2
			mul r0.rgb, r0, r1
			+mul r0.a, 1-t0.a, t1.a
        };   
    }
    
    pass P6
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			mad		r3, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			mad		r1, r3, c52.xxxw, v0	// multiply normal by constant
			m4x4	r0, r1, c92				// Apply view+proj
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			dp3		r2, r3, -c81			// Dot for diffuse
			lit		r2, r2
			mul		oD0, r2.yyyw, c83

			// Move the uvs through...
			mul		r0, v7, c91.x			// scale UVs
			add		oT0.xyz, r0, c60		// mov UVs for alpha texture
			
			mul		oT1.xyz, v0, c58		// generate uv's for grass texture
			
			mul		r0, v9, c91.x			// scale UVs
			add		oT2.xyz, r0, c62		// mov UVs for alpha texture

			// Compute uvs for shadow buffers
			m4x4	r1, v0, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2
			tex t3

			mad r0.rgb, v0, t3, c0
			+mov r0.a, v0.a
			mul_x2 r1.rgb, t1, t2
			mul r0.rgb, r0, r1
			+mul r0.a, 1-t0.a, t1.a
        };   
    }
    
    pass P7
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
            stream 3;
            short v9[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			mad		r3, v3, c91.z, -v3.w	// EXPECTING 1.0 to be in v3.w
			mad		r1, r3, c52.yyyw, v0	// multiply normal by constant
			m4x4	r0, r1, c92				// Apply view+proj
			mov		oPos, r0
			mov		oFog.x, r0.w
			
			// Lighting (diffuse + ambient + emissive)
			dp3		r2, r3, -c81			// Dot for diffuse
			lit		r2, r2
			mul		oD0, r2.yyyw, c83

			// Move the uvs through...
			mul		r0, v7, c91.x			// scale UVs
			add		oT0.xyz, r0, c60		// mov UVs for alpha texture
			
			mul		oT1.xyz, v0, c58		// generate uv's for grass texture
			
			mul		r0, v9, c91.x			// scale UVs
			add		oT2.xyz, r0, c62		// mov UVs for alpha texture

			// Compute uvs for shadow buffers
			m4x4	r1, v0, c76
			max		oT3, r1, c86.wwwz	// Clamps W to be >= 0.0 (xyz should pass through)
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2
			tex t3

			mad r0.rgb, v0, t3, c0
			+mov r0.a, v0.a
			mul_x2 r1.rgb, t1, t2
			mul r0.rgb, r0, r1
			+mul r0.a, 1-t0.a, t1.a
        };   
    }
}