technique T0
{
    pass P0
    {
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= False;
		
		// Set alpha blending mode
		AlphaBlendEnable = True;
		SrcBlend		= SrcAlpha;
		DestBlend		= InvSrcAlpha;
		AlphaTestEnable = True;
		AlphaRef		= 5;
						
		// Set texture address mode and min mag filters
		MipFilter[3]	= Point;
		MinFilter[3]	= Point;
		MagFilter[3]	= Point;
		MipMapLODBias[3]= -1;
		
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
        }
		asm
		{
			vs.1.1

			// Transform position -- apply view+proj
			m4x4	r0, v0, c92
			mov		oPos, r0
			mov		oFog.x, r0.w

			// Set the Alpha Value
			mov				oD0.w, c3.y

			// Set the Point Size
			rcp				r0.x, r0.w
			mul				oPts.x, r0.x, c3.x
			
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t3

			mov r0.rgb, t3
			+mul r0.a, t3, v0
        };   
    }
}
