
technique T0
{
    pass P0
    {
		SpecularEnable = false;

		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v5[1];	// Diffuse
            float v7[2];	// UV
            float v8[2];	// UV
            float v9[2];	// UV
            float v10[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			add		r1, v0, c90
			m4x4	r0, r1, c92
			sge		r0.z, r1, r1 // force a z buffer value of 1
			mov		oPos, r0

			// Move diffuse color
			mov		oD0, v5
			
			// Move the uvs through...
			mov		oT0, v7		// haze layer
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0

			mov r0, v0
			lrp r0, t0.a, t0, r0
        };   
    }
    
    pass P1
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v5[1];	// Diffuse
            float v7[2];	// UV
            float v8[2];	// UV
            float v9[2];	// UV
            float v10[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			add		r1, v0, c90
			m4x4	r0, r1, c92
			sge		r0.z, r1, r1 // force a z buffer value of 1
			mov		oPos, r0

			// Move the uvs through...
			add		oT0, v8, c60	// cloud layer 1
			add		oT1, v9, c61	// cloud layer 2
			mov		oT2, v10		// texture for fading clouds on the edges
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2

			mul r0.rgb, t0, c[0]
			+ mul r0.a, t0.a, t2.a

			mul t1.rgb, t1, c[1]
			+ mul r1.a, t1.a, t2.a

			lrp r0, r1.a, t1, r0
        };   
    }
}

technique T1
{
    pass P0
    {
		// First stage
        ColorOp[0]   = SelectArg1;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Texture;
        AlphaOp[0]   = SelectArg1;
        AlphaArg1[0] = Texture;
        AlphaArg2[0] = Texture;
        
        // Second stage
        ColorOp[1]   = BlendTextureAlpha;
        ColorArg1[1] = Texture;
        ColorArg2[1] = Current;
        
        AlphaOp[1]   = SelectArg1;
        AlphaArg1[1] = Texture;
        AlphaArg2[1] = Current;
        
        // Third stage
        ColorOp[2]	 = Disable;
        AlphaOp[2]   = Disable;
 	
		VertexShader = 
		decl
        {
            stream 0;
            float v0[3];	// Position
            float v7[2];	// UV
            float v8[2];	// UV
        }
        asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			add		r1, v0, c90
			m4x4	r0, r1, c92
			sge		r0.z, r1, r1 // force a z buffer value of 1
			mov		oPos, r0
			
			slt		oFog.x, v0, v0
			
			// Move the uvs through...
			add		oT0, v7, c60
			add		oT1, v8, c61
		};
    }
}