technique T0
{
    pass P0
    {
		// Disable specular
		SpecularEnable = False;
		
        // Z-buffering to be used
        ZEnable	     = False;
        ZWriteEnable = False;
        
        // Set alpha blending mode
		AlphaBlendEnable = False;
		AlphaTestEnable = False;
		CullMode = None;
		
		MipFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		MinFilter[0]	= Linear;
		
		MipFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		MinFilter[1]	= Linear;
		
		MipFilter[2]	= Linear;
		MagFilter[2]	= Linear;
		MinFilter[2]	= Linear;
		
		AddressU[0] = Wrap;
		AddressV[0] = Wrap;

		AddressU[1] = Wrap;
		AddressV[1] = Wrap;

		AddressU[2] = Wrap;
		AddressV[2] = Wrap;

        VertexShader =
        decl
        {
            stream 0;
            float v0[3];		// Position
            float v7[2];		// Texture coord1
        }
		asm
		{
			vs.1.1

			mov	oPos, v0		// Move coords directly through
			add	oT0, v7, c0		// Translate uv0
			add oT1, v7, c1		// translate uv1
			add oT2, v7, c2		// translate uv2
		};

        PixelShader = 
        asm
        {
			xps.1.1

			tex t0
			tex t1
			tex t2

			mul		r0, t0_bx2, c0
			mad		r0, t1_bx2, c0, r0
			mad		r0, t2_bx2, c0, r0

			add_d2	r0, r0, 1-zero //c1

			xfc zero, zero, zero, r0, zero, zero, 1-zero
		};
    }
}
