technique T0
{
    pass P0
    {
		// Disable specular
		SpecularEnable = False;
		
        // Z-buffering to be used
        ZEnable	     = False;
        ZWriteEnable = False;
        
        // Set alpha blending mode
		AlphaBlendEnable = False;
		AlphaTestEnable = False;
		CullMode = None;

		AddressU[0] = Wrap;
		AddressV[0] = Wrap;

		AddressU[1] = Wrap;
		AddressV[1] = Wrap;

		AddressU[2] = Wrap;
		AddressV[2] = Wrap;

		AddressU[3] = Wrap;
		AddressV[3] = Wrap;
		
        VertexShader =
        decl
        {
            stream 0;
            float v0[3];		// Position
            float v7[2];		// Texture coord1
        }
		asm
		{
			vs.1.1

			mov	oPos, v0		// Move coords directly through
			add	oT0, v7, c0		// Translate uv0
			add oT1, v7, c1		// translate uv1
			add oT2, v7, c2		// translate uv2
			add	oT3, v7, c3		// move uv3 through
		};

        PixelShader = 
        asm
        {
			// Declare pixel shader version
			xps.1.1

			// Define c0 as RGBA = (scale, 0, 0, 0)
			//  Where scale [0,1] is applied to reduce the magnitude
			//  of the s axis component of the normal.
			// Define c1 similarly to affect the 
			//  t axis component

			// get colors from all 4 texture stages
			// t0 = -s,  0
			// t1 = +s,  0
			// t2 =  0, +t
			// t3 =  0, -t

			tex t0
			tex t1
			tex t2
			tex t3

			sub_x2  r0, t0, t1			// (t0 - t1)*4  : 4 for higher scale
			mul     t0, r0, c0			// t0 = s result in red only

			sub_x2  r1, t3, t2			// r1 = t result in green only

			mad     r0, r1, c1, t0		// r0 = red,green for s and t result

			mul_x2  t1, r0, r0          // t1 = ( 2 * s^2, 2 * t^2, 0.0)

			dp3_d2  r1, 1-t1, c3        // ( 1-2s^2 + 1-2t^2 )/2 = 1 - s^2 - t^2

			add     r0, r0, c2          // bias red,green to 0.5

			mad     r0, r1, c4, r0      // RGB = (r+0, g+0, 0+blue )
			
			xfc zero, zero, zero, r0, zero, zero, 1-zero
		};
    }
}
